## org.apache.mahout.cf.taste.impl.recommender.knn
Class NonNegativeQuadraticOptimizer

    java.lang.Object
      org.apache.mahout.cf.taste.impl.recommender.knn.NonNegativeQuadraticOptimizer

All Implemented Interfaces:
  Optimizer

    public final class NonNegativeQuadraticOptimizer

extends java.lang.Object
implements Optimizer

Non-negative Quadratic Optimization. Based on the paper of Robert M. Bell and Yehuda Koren in ICDM '07. Thanks to Dan Tillberg for the hints in the implementation.

Constructor Summary
`NonNegativeQuadraticOptimizer()`

Method Summary
`double[]` `optimize(double[][] matrix, double[] b)` Non-negative Quadratic Optimization.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### NonNegativeQuadraticOptimizer

    public NonNegativeQuadraticOptimizer()

Method Detail

### optimize

    public double[] optimize(double[][] matrix,
                             double[] b)

  Non-negative Quadratic Optimization.

  Specified by:
    `optimize` in interface `Optimizer`
  Parameters:
    `matrix` - matrix nxn positions
    `b` - vector b, n positions
  Returns:
    vector of n weights

Copyright © 2008-2010 The Apache Software Foundation. All Rights Reserved.